diff --git a/subsys/net/ip/net_pkt.c b/subsys/net/ip/net_pkt.c
index 283e910fb78e..94025c7c6a1a 100644
--- a/subsys/net/ip/net_pkt.c
+++ b/subsys/net/ip/net_pkt.c
@@ -35,6 +35,7 @@ LOG_MODULE_REGISTER(net_pkt, CONFIG_NET_PKT_LOG_LEVEL);
 #include <net/net_ip.h>
 #include <net/buf.h>
 #include <net/net_pkt.h>
+#include <net/ethernet.h>
 #include <net/udp.h>
 #include <net/tcp.h>
 
@@ -2306,6 +2307,19 @@ static size_t pkt_buffer_length(struct net_pkt *pkt,
 		max_len = max(max_len, NET_IPV6_MTU);
 	} else if (IS_ENABLED(CONFIG_NET_IPV4) && family == AF_INET) {
 		max_len = max(max_len, NET_IPV4_MTU);
+	} else { /* family == AF_UNSPEC */
+#if defined (CONFIG_NET_L2_ETHERNET)
+		if (net_if_l2(net_pkt_iface(pkt)) ==
+		    &NET_L2_GET_NAME(ETHERNET)) {
+			max_len += sizeof(struct net_eth_hdr);
+		} else
+#endif /* CONFIG_NET_L2_ETHERNET */
+		{
+			/* Other L2 are not checked as the pkt MTU in this case
+			 * is based on the IP layer (IPv6 most of the time).
+			 */
+			max_len = size;
+		}
 	}
 
 	max_len -= existing;
diff --git a/tests/net/net_pkt_new/src/main.c b/tests/net/net_pkt_new/src/main.c
index 5bd3fbf44239..95dceb6790c0 100644
--- a/tests/net/net_pkt_new/src/main.c
+++ b/tests/net/net_pkt_new/src/main.c
@@ -60,6 +60,7 @@ static const struct ethernet_api fake_dev_api = {
 
 #define _ETH_L2_LAYER ETHERNET_L2
 #define _ETH_L2_CTX_TYPE NET_L2_GET_CTX_TYPE(ETHERNET_L2)
+#define L2_HDR_SIZE sizeof(struct net_eth_hdr)
 #else
 static const struct dummy_api fake_dev_api = {
 	.iface_api.init = fake_dev_iface_init,
@@ -68,6 +69,7 @@ static const struct dummy_api fake_dev_api = {
 
 #define _ETH_L2_LAYER DUMMY_L2
 #define _ETH_L2_CTX_TYPE NET_L2_GET_CTX_TYPE(DUMMY_L2)
+#define L2_HDR_SIZE 0
 #endif
 
 NET_DEVICE_INIT(fake_dev, "fake_dev",
@@ -154,7 +156,7 @@ static void test_net_pkt_allocate_with_buffer(void)
 	zassert_true(pkt != NULL, "Pkt not allocated");
 
 	zassert_false(pkt_is_of_size(pkt, 1800), "Pkt size is not right");
-	zassert_true(pkt_is_of_size(pkt, net_if_get_mtu(eth_if)),
+	zassert_true(pkt_is_of_size(pkt, net_if_get_mtu(eth_if) + L2_HDR_SIZE),
 		     "Pkt size is not right");
 
 	/* Freeing the packet */
